# Ən uzun səyahət

İOİ 2023'ün orqanizatorları çətin vəziyyətə düşüblər. Onlar növbəti günlər üçün Ópusztaszer kəndinə səyahət planlamağı unudublar. Amma bəlkə hələ də çox gec deyil...

Ópusztaszer'da $0$'dan $N-1$'ə nömrələnmiş $N$ sayda görülməli məkan var. 
Bu yerlərin bəziləri *iki istiqamətli* **yollarla** əlaqələndirilib. 
Hər bir məkan cütü ən çox bir yol ilə əlaqələndirilib.
Orqanizatorlar hansı yerlər bir-biri ilə əlaqələndirilib *bilmirlər*.

Ópusztaszer'da olan yol şəbəkəsində istənilən $3$ müxtəlif məkan arasında ən az $\delta$ sayda yol varsa, bu şəbəkənin **sıxlığına** $\delta$ deyək. 
Başqa sözlə, $0 \le u \lt v \lt w \lt N$ şərtini ödəyən istənilən $(u, v, w)$ üçlüyü üçün, $(u,v), (v,w)$ və $(u,w)$ cütləri arasında ən az $\delta$ sayda cüt yol ilə əlaqələndirilib. 

Orqanizatorlar elə bir $D$ ədədi *bilir* ki, bu şəbəkənin sıxlığı ən az $D$'dir. Nəzər yetirin ki, $D$ $3$'dən böyük ola bilməz. 

Orqanizatorlar Ópusztaszer'a **zənglər** edərək bəzi məkanlar arasındakı yollar barədə məlumatlar ala bilərlər.
Hər bir zəngdə iki boş olmayan $[A[0], \ldots, A[P-1]]$ və $[B[0], \ldots, B[R-1]]$ məkan massivləri verilməlidir. Bütün məkanlar müxtəlif olmalıdır, yəni
* $A[i] \neq A[j]$, $0 \le i \lt j \lt P$ şərtini ödəyən hər $i$ və $j$ üçün;
* $B[i] \neq B[j]$, $0 \le i \lt j \lt R$ şərtini ödəyən hər $i$ və $j$ üçün;
* $A[i] \neq B[j]$, $0 \le i \lt P$ və $0\le j \lt R$ şərtini ödəyən hər $i$ və $j$ üçün.

Hər zəngə cavab olaraq $A$ və $B$ arasında əlaqə olub olmadığı deyilir. Daha dəqiq, bütün $i$, $j$ ($0 \le i \lt P$, $0\le j \lt R$) cütləri üçün $A[i]$ və $B[j]$ arasında yol olub-olmadığına baxılır və əgər  hər hansı $A[i]$ və $B[j]$ arasında yol olarsa, o zaman `true`, əks halda `false` cavabı qayıdır.

$l$ uzunluqlu $t[0], t[1], \ldots, t[l-1]$ məkan ardıcıllığına o vaxt **səyahət** deyək ki, bütün məkanlar müxtəlif olsun, $0$ və $l-2$ arasında olan hər $i$ üçün $t[i]$ və $t[i+1]$ məkanları arasında yol olsun. $l$ uzunluqlu səyahət o zaman **ən uzun səyahət** adlansın ki, $l+1$ uzunluqlu səyahət olmasın.

Sizin vəzifəniz Ópusztaszer'da olan ən uzun səyahəti tapmaqda orqanizatorlara kömək etməkdir.

## İmplementasiya detalları

Aşağıdakı proseduru implement etməlisiniz:

```
int[] longest_trip(int N, int D)
```

* $N$: Ópusztaszer'da olan məkanların sayı.
* $D$: yol şəbəkəsinin zəmanət verilən ən az sıxlığı
* Bu prosedur ən uzun səyahəti göstərən $t = [t[0], t[1], \ldots, t[l-1]]$ massivini qaytarmalıdır.
* Bu prosedur hər test zamanı **bir neçə dəfə çağırıla bilər**.

Yuxarıda verilən prosedur aşağıdakı proseduru çağıra bilər:

```
bool are_connected(int[] A, int[] B)
```

* $A$: boş olmayan müxtəlif məkan massivi.
* $B$: boş olmayan müxtəlif məkan massivi.
* $A$ və $B$ massivinin ortaq elementi yoxdur.
* Əgər $A$'dakı hər hansı məkan ilə $B$'dəki hər hansı məkan arasında yol varsa bu zaman prosedur `true`, əks halda `false` qaytarır.
* Bu prosedur hər `longest_trip` proseduru zamanı ən çox $32\,640$ dəfə çağırıla bilər, ümumilikdə isə ən çox $150\,000$ dəfə çağırıla bilər.
* $A$ və $B$ massivinin ümumi uzunluqlarının cəmi $1\,500\,000$'i keçməməlidir.

Qreyder adaptiv **deyil**. Hər bir həll eyni testlər üzərində yoxlanılır. Yəni $N$ və $D$ dəyərləri, həmçinin hansı məkanlar arasında yollar olduğu hər bir test daxilində `longest_trip` prosedurunun hər bir çağırışı üçün dəyişməzdir.

## Nümunələr

### Nümunə 1

$N = 5$, $D = 1$, və yolların aşağıdakı kimi qoşulduğu bir ssenariyə nəzər yetirək:

![Example1](longesttrip-ex1.png "200")

`longest_trip` proseduru aşağıdakı kimi çağırılır:
```
longest_trip(5, 1)
```

Bu prosedur `are_connected` proseduruna aşağdakı kimi çağırışlar edə bilər.

Çağırış                               | Qoşulu olan yollar | Qaytarılan dəyər
:---------------------------------:|:-------------------------:|:--------------:
`are_connected([0], [1, 2, 4, 3])` | $(0,1)$ və $(0,2)$       | `true`
`are_connected([2], [0])`          | $(2,0)$                   | `true`
`are_connected([2], [3])`          | $(2,3)$                   | `true`
`are_connected([1, 0], [4, 3])`    | heç biri                      | `false`

Dördüncü çağırışda məlum olur ki  $(1,4)$, $(0,4)$, $(1,3)$ və $(0,3)$ cütlərinin *heç biri* arasında yol yoxdur. 
Şəbəkənin sıxlığı ən az $D = 1$ olduğuna görə, $(0, 3, 4)$ üçlüyündən $(3, 4)$ cütü arasında yol olmalıdır. Oxşar şəkildə, $0$ və $1$ məkanları arasında da yol olmalıdır.

Burada artıq $5$ uzunluqlu $t = [1, 0, 2, 3, 4]$ ardıcıllığının ən uzun səyahət olduğunu deyə bilirik, və daha uzun səyahət tapmaq mümkün deyil. Buna görə də `longest_trip` proseduru $[1, 0, 2, 3, 4]$ qaytara bilər.

$N = 4$, $D = 1$, və yolların aşağıdakı kimi qoşulduğu başqa bir ssenariyə baxaq:

![Example2](longesttrip-ex2.png "200")

`longest_trip` proseduru aşağıdakı kimi çağırılır:
```
longest_trip(4, 1)
```

Burada ən uzun səyahətin uzunluğu $2$'dir. Buna görə də `are_connected`'ə olan bir neçə çağırışdan sonra `longest_trip` proseduru $[0, 1]$, $[1, 0]$, $[2, 3]$ or $[3, 2]$ cütlərindən hər hansı birini qaytara bilər

### Nümunə 2

0'cı alt tapşırığında əlavə olaraq $N=256$ olan test var. Bu testi yarış sistemində olan yükləyə bildiyiniz əlavənin içində görə bilərsiniz.

## Məhdudiyyətlər

* $3 \le N \le 256$
* `longest_trip`'ə olan çağırışlarda $N$'lərin cəmi $1\,024$'ü keçmir.
* $1 \le D \le 3$


## Alt tapşırıqlar

1. (5 bal) $D = 3$
1. (10 bal) $D = 2$
1. (25 bal) $D = 1$. $l^\star$ ən uzun səyahətin uzunluğunu göstərsin. `longest_trip` proseduru $l^\star$ uzunluqlu səyahət qaytarmaq məcburiyyətində deyil. Əvəzində ən az $\left\lceil \frac{l^\star}{2} \right\rceil$ uzunluqlu səyahət qaytarmağı kifayətdir.
1. (60 bal) $D = 1$

4'cü alt tapşırıqda sizin balınız bir `longest_trip` proseduru zamanı `are_connected` proseduruna olan çağırışların sayından asılı olacaq. Alt tapşırığın hər testindəki bütün `longest_trip` çağırışları zamanı `are_connected` maksimum $q$ dəfə çağırılmış olsun. Sizin balınız aşağıdakı cədvələ uyğun hesablanacaq.

Şərt                  |  Bal
:-------------------------:|:----------------------:
$2\,750 \lt q \le 32\,640$ |  $20$
$550 \lt q \le 2\,750$     |  $30$
$400 \lt q \le 550$        |  $45$
$q \le 400$                |  $60$

Əgər hər hansı test'də `are_connected` proseduruna olan çağırışlar İmplementasiya Detallarında verilən şərtlərə uyğun gəlməsə və ya `longest_trip`'in qaytardığı cavab səhv olarsa, uyğun alt tapşırıq $0$ bal verəcək. 

## Nümunə qreyder

$C$ ssenarilərin sayını, yəni `longest_trip` proseduruna olan çağırışların sayını göstərsin. Nümunə qreyder girişi aşağıdakı formada oxuyur:


* sətir $1$: $C$

$C$ ssenarinin izahı ilə giriş davam edir.

Nümunə qreyder hər ssenarinin izahını aşağıdakı formatda oxuyur:

* sətir $1$: $N \; D$
* sətir $1 + i$ ($1 \le i \lt N$): $U_i[0] \; U_i[1] \; \ldots \; U_i[i-1]$

Burada hər bir $U_i$ ($1 \le i \lt N$) $i$ ölçülü bir massivdir və məkanlar arasındakı yolları göstərir.
$1 \le i \lt N$ və $0 \le j \lt i$ şərtini ödəyən hər bir $i$ və $j$ üçün:
* əgər $j$ və $i$ məkanı arasında yol varsa o zaman $U_i[j]$ dəyəri $1$ olmalıdır;
* əgər $j$ və $i$ məkanı arasında yol yoxdursa o zaman $U_i[j]$ dəyəri $0$ olmalıdır.

<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Hər bir ssenaridə `longest_trip` çağırılmazdan əvvəl nümunə qreyder yol şəbəkəsinin sıxlığının ən az $D$ olub olmadığını yoxlayır. 
Əgər şərt ödənməsə `Insufficient Density`  mesajı göstərir və dayanır.

Əgər nümunə qreyder protokoldan kənara çıxma təyin edərsə o zaman çıxışa `Protocol Violation: <MSG>` verir. Burada `<MSG>` aşağıdakı mesajlardan biridir:

* `invalid array`: `are_connected` proseduruna olan çağırışların birində, ya $A$ ya da $B$
    - boşdur, və ya
    - $0$ və $N-1$ arasında olmayan bir ədəd var, və ya
    - hansısa elementdən orda ən az iki ədəd var.
* `non-disjoint arrays`: `are_connected` çağırılması üçün istifadə edilən , $A$ və $B$ massivlərinin ortaq elementi var.
* `too many calls`: bir `longest_trip` çağırışı zaman `are_connected`'a olan çağırışların sayı $32\,640$'ı və ya ümumi limit olan $150\,000$'i aşır.
* `too many elements`: `are_connected`'a olan bütün çağırışlarda  istifadə olunan massivlərdəki elementlərin sayları cəmi $1\,500\,000$'i keçir.

Əks halda, `longest_trip` prosedurunun qaytardığı massiv hansısa mənfi olmayan $l$ ədədi üçün $t[0], t[1], \ldots, t[l - 1]$ olsun. 
Nümunə qreyder bu ssenari üçün aşağıdakı formatda üç sətir çıxışa verir:

* sətir $1$: $l$
* sətir $2$: $t[0] \; t[1] \; \ldots \; t[l-1]$
* sətir $3$: bu ssenaridə `are_connected` proseduruna olan çağırışların sayı

Ən sonda nümunə qreyder aşağıdakı məlumatı çıxışa verir:

* sətir $1 + 3 \cdot C$: bütün `longest_trip` prosedurları arasında `are_connected` proseduruna olan maksimum çağırışların sayı
