# Longest Trip (Η μεγαλύτερη διαδρομή)

Οι διοργανωτές της IOI 2023 έχουν μεγάλο πρόβλημα! Ξέχασαν να προγραμματίσουν τη διαδρομή στο Ópusztaszer για την επόμενη ημέρα. 
Αλλά ίσως δεν είναι ακόμα πολύ αργά ...

Υπάρχουν $N$ αξιοθέατα στο Ópusztaszer αριθμημένα από $0$ μέχρι $N-1$. 
Ορισμένα ζεύγη αυτών των αξιοθέατων συνδέονται με **δρόμους** *διπλής κατεύθυνσης*.
Κάθε ζεύγος αξιοθέατων συνδέεται το πολύ με έναν δρόμο.
Οι διοργανωτές *δεν γνωρίζουν* ποια αξιοθέατα συνδέονται με δρόμους.

Λέμε ότι η **πυκνότητα** του οδικού δικτύου στο Ópusztaszer είναι **τουλάχιστον** $\delta$ αν κάθε $3$ διαφορετικά αξιοθέατα έχουν τουλάχιστον $\delta$ δρόμους μεταξύ τους.
Με άλλα λόγια, για κάθε τριπλέτα αξιοθέατων $(u, v, w)$ τέτοια ώστε $0 \le u \lt v \lt w \lt N$, μεταξύ των ζευγών αξιοθέατων $(u,v), (v,w)$ και $(u,w)$ τουλάχιστον $\delta$ ζεύγη συνδέονται με δρόμο.

Οι διοργανωτές *γνωρίζουν* έναν θετικό ακέραιο αριθμό $D$ τέτοιον ώστε η πυκνότητα του οδικού δικτύου να είναι τουλάχιστον $D$.
Σημειώστε ότι η τιμή του $D$ δεν μπορεί να είναι μεγαλύτερη από $3$.

Οι διοργανωτές μπορούν να κάνουν **κλήσεις** στο τηλεφωνικό κέντρο του Ópusztaszer για να συλλέξουν πληροφορίες σχετικά με τις οδικές συνδέσεις μεταξύ ορισμένων αξιοθέατων.
Σε κάθε κλήση, πρέπει να προσδιορίζονται δύο μη κενοί πίνακες αξιοθέατων $[A[0], \ldots, A[P-1]]$ και $[B[0], \ldots, B[R-1]]$.
Τα αξιοθέατα πρέπει να είναι κατά ζεύγη διακριτά, δηλαδή,
* $A[i] \neq A[j]$ για κάθε $i$ και $j$ τέτοια ώστε $0 \le i \lt j \lt P$;
* $B[i] \neq B[j]$ για κάθε $i$ και $j$ τέτοια ώστε $0 \le i \lt j \lt R$;
* $A[i] \neq B[j]$ για κάθε $i$ και $j$ τέτοια ώστε $0 \le i \lt P$ και $0\le j \lt R$.

Για κάθε κλήση, το τηλεφωνικό κέντρο αναφέρει εάν υπάρχει δρόμος που συνδέει ένα αξιοθέατο από το $A$ με ένα αξιοθέατο από το $B$.
Πιο συγκεκριμένα, το τηλεφωνικό κέντρο επαναλαμβάνει όλα τα ζεύγη $i$ και $j$ έτσι ώστε $0 \le i \lt P$ και $0\le j \lt R$.
Εάν, για οποιοδήποτε από αυτά τα ζεύγη, τα αξιοθέατα $A[i]$ και $B[j]$ συνδέονται με δρόμο, το τηλεφωνικό κέντρο επιστρέφει `true`.
Διαφορετικά, επιστρέφει `false`.

Μια **διαδρομή** μήκους $l$ είναι μια ακολουθία *διαφορετικών* αξιοθέατων $t[0], t[1], \ldots, t[l-1]$, 
όπου για κάθε $i$ μεταξύ $0$ και $l-2$, συμπεριλαμβανομένων, το αξιοθέατο $t[i]$ και το αξιοθέατο  $t[i+1]$ συνδέονται με δρόμο.
Μια διαδρομή μήκους $l$ ονομάζεται **μεγαλύτερη διαδρομή** αν δεν υπάρχει καμιά άλλη διαδρομή μήκους τουλάχιστον $l+1$.

Η αποστολή σας είναι να βοηθήσετε τους διοργανωτές να βρουν μία μεγαλύτερη διαδρομή στο Ópusztaszer κάνοντας κλήσεις στο τηλεφωνικό κέντρο.

## Λεπτομέρειες Υλοποίησης

Θα πρέπει να υλοποιήσετε την ακόλουθη συνάρτηση:

```
int[] longest_trip(int N, int D)
```

* $N$: το πλήθος των αξιοθέατων στο Ópusztaszer.
* $D$: η ελάχιστη εγγυημένη πυκνότητα του οδικού δικτύου.
* Αυτή η συνάρτηση πρέπει να επιστρέφει έναν πίνακα $t = [t[0], t[1], \ldots, t[l-1]]$, που αντιπροσωπεύει τη μεγαλύτερη διαδρομή.
* Αυτή η συνάρτηση μπορεί να κληθεί **πολλές φορές** σε κάθε test case.

Η πιο πάνω συνάρτηση μπορεί να καλέσει την ακόλουθη συνάρτηση:

```
bool are_connected(int[] A, int[] B)
```

* $A$: ένας μη κενός πίνακας διακριτών αξιοθέατων.
* $B$: ένας μη κενός πίνακας διακριτών αξιοθέατων.
* $A$ και $B$ θα πρέπει να είναι ασύνδετοι (disjoint).
* Αυτή η συνάρτηση επιστρέφει `true` εάν υπάρχει ένα αξιοθέατο από τον πίνακα $A$ και ένα αξιοθέατο από τον πίνακα $B$ που συνδέονται με δρόμο. Διαφορετικά, επιστρέφει `false`.
* Η συνάρτηση αυτή μπορεί να κληθεί το πολύ $32\,640$ φορές σε κάθε κλήση της `longest_trip`, και το πολύ $150\,000$ φορές συνολικά.
* Το συνολικό μέγεθος των πινάκων $A$ και $B$ που στέλνονται σ' αυτήν τη συνάρτηση σε όλες τις κλήσεις της δεν μπορεί να υπερβαίνει το $1\,500\,000$.

Ο grader είναι **μη προσαρμόσιμος (not adaptive)**. Κάθε υποβολή βαθμολογείται με βάση το ίδιο σύνολο test cases. Δηλαδή, οι τιμές των $N$ και $D$, καθώς και τα ζεύγη αξιοθέατων που συνδέονται με δρόμους, είναι σταθερά για κάθε κλήση της `longest_trip` σε κάθε test case.

## Παραδείγματα

### Παράδειγμα 1

Σκεφτείτε ένα σενάριο στο οποίο $N = 5$, $D = 1$, και οι οδικές συνδέσεις είναι όπως φαίνονται στο ακόλουθο σχήμα:

![Example1](longesttrip-ex1.png "200")

Η συνάρτηση `longest_trip` καλείται με τον ακόλουθο τρόπο:
```
longest_trip(5, 1)
```

Η συνάρτηση μπορεί να καλεί την `are_connected` ως εξής:

Κλήση                               | Ζεύγη που συνδέονται με δρόμο |  Επιστρεφόμενη τιμή
:---------------------------------:|:-------------------------:|:--------------:
`are_connected([0], [1, 2, 4, 3])` | $(0,1)$ και $(0,2)$       | `true`
`are_connected([2], [0])`          | $(2,0)$                   | `true`
`are_connected([2], [3])`          | $(2,3)$                   | `true`
`are_connected([1, 0], [4, 3])`    | κανένα                      | `false`

Μετά την τέταρτη κλήση, αποδεικνύεται ότι *κανένα* από τα ζεύγη $(1,4)$, $(0,4)$, $(1,3)$ και $(0,3)$ συνδέονται με δρόμο.
Καθώς η πυκνότητα του δικτύου είναι τουλάχιστον $D = 1$, βλέπουμε ότι από την τριπλέτα $(0, 3, 4)$, το ζεύγος $(3,4)$ πρέπει να συνδέεται με δρόμο.
Ομοίως, τα αξιοθέατα $0$ και $1$ πρέπει να συνδέονται μεταξύ τους.

Σε αυτό το σημείο, μπορεί να βγει το συμπέρασμα ότι $t = [1, 0, 2, 3, 4]$ είναι μια διαδρομή μήκους $5$, και ότι δεν υπάρχει διαδρομή με μήκος μεγαλύτερο από $5$.
Επομένως, η συνάρτηση `longest_trip` μπορεί να επιστρέψει $[1, 0, 2, 3, 4]$.

Σκεφτείτε ένα άλλο σενάριο στο οποίο $N = 4$, $D = 1$, και οι διαδρομές μεταξύ των αξιοθέατων είναι όπως φαίνεται στο ακόλουθο σχήμα:

![Example2](longesttrip-ex2.png "200")

Η συνάρτηση `longest_trip` καλείται με τον ακόλουθο τρόπο:
```
longest_trip(4, 1)
```

Σε αυτό το σενάριο, το μήκος της μεγαλύτερης διαδρομής είναι $2$. Επομένως, μετά από μερικές κλήσεις της συνάρτησης `are_connected`, η συνάρτηση `longest_trip` μπορεί να επιστρέψει ένα από τα $[0, 1]$, $[1, 0]$, $[2, 3]$ or $[3, 2]$.

### Παράδειγμα 2

Το υποπρόβλημα 0 περιέχει ένα πρόσθετο παράδειγμα test case με $N=256$ αξιοθέατα.
Αυτό το test case περιλαμβάνεται στα συνημμένα που μπορείτε να κατεβάσετε από το σύστημα του διαγωνισμού.

## Περιορισμοί

* $3 \le N \le 256$
* Το άθροισμα των $N$ σε όλες τις κλήσεις της `longest_trip` δεν υπερβαίνει το $1\,024$ σε κάθε test case.
* $1 \le D \le 3$


## Υποπροβλήματα

1. (5 βαθμοί) $D = 3$
1. (10 βαθμοί) $D = 2$
1. (25 βαθμοί) $D = 1$. Έστω $l^\star$ το μήκος μιας μεγαλύτερης διαδρομής. Η συνάρτηση `longest_trip` δεν είναι απαραίτητο να επιστρέψει μια διαδρομή μήκους $l^\star$. Αντίθετα, πρέπει να επιστρέφει μια διαδρομή μήκους τουλάχιστον $\left\lceil \frac{l^\star}{2} \right\rceil$.
1. (60 βαθμοί) $D = 1$

Στο υποπρόβλημα 4 η βαθμολογία σας καθορίζεται με βάση τον αριθμό των κλήσεων της συνάρτησης `are_connected` κατά τη διάρκεια μιας μόνο κλήσης της `longest_trip`.
Έστω $q$ ο μέγιστος αριθμός κλήσεων μεταξύ όλων των κλήσεων της `longest_trip` σε κάθε περίπτωση δοκιμής του υποπροβλήματος.
Η βαθμολογία σας για αυτό το υποπρόβλημα υπολογίζεται σύμφωνα με τον ακόλουθο πίνακα:

Περίπτωση                  |  Βαθμοί
:-------------------------:|:----------------------:
$2\,750 \lt q \le 32\,640$ |  $20$
$550 \lt q \le 2\,750$     |  $30$
$400 \lt q \le 550$        |  $45$
$q \le 400$                |  $60$

Εάν σε οποιαδήποτε από τα test cases οι κλήσεις της συνάρτησης `are_connected` δεν συμμορφώνονται με τους περιορισμούς που περιγράφονται στην ενότητα Λεπτομέρειες Υλοποίησης, ή ο πίνακας που επιστρέφει η `longest_trip` είναι λανθασμένος, η βαθμολογία της λύσης σας για το συγκεκριμένο υποπρόβλημα θα είναι $0$.

## Ενδεικτικός Grader

Έστω $C$ ο αριθμός των σεναρίων, δηλαδή, τον αριθμό των κλήσεων της `longest_trip`.
Ο ενδεικτικός grader διαβάζει την είσοδο με την ακόλουθη μορφή:

* γραμμή $1$: $C$

Ακολουθούν οι περιγραφές των $C$ σεναρίων.

Ο ενδεικτικός grader διαβάζει την περιγραφή του κάθε σεναρίου με την ακόλουθη μορφή:

* γραμμή $1$: $N \; D$
* γραμμή $1 + i$ ($1 \le i \lt N$): $U_i[0] \; U_i[1] \; \ldots \; U_i[i-1]$

Εδώ, κάθε $U_i$ ($1 \le i \lt N$) είναι ένας πίνακας μεγέθους $i$, που περιγράφει ποια ζεύγη σημείων συνδέονται με δρόμο.
Για κάθε $i$ και $j$ τέτοια ώστε $1 \le i \lt N$ και $0 \le j \lt i$:
* εάν τα αξιοθέατα $j$ και $i$ συνδέονται με δρόμο, τότε η τιμή του $U_i[j]$ πρέπει να είναι $1$;
* αν δεν υπάρχει δρόμος που να συνδέει τα ορόσημα $j$ και $i$, τότε η τιμή του $U_i[j]$ θα πρέπει να είναι $0$.

<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Σε κάθε σενάριο, πριν από την κλήση της `longest_trip`, ο ενδεικτικός grader ελέγχει αν η πυκνότητα του οδικού δικτύου είναι τουλάχιστον $D$.
Εάν αυτή η συνθήκη δεν ικανοποιείται, εκτυπώνει το μήνυμα `Insufficient Density` και τερματίζει.

Εάν ο ενδεικτικός grader εντοπίσει παραβίαση πρωτοκόλλου, η έξοδος του ενδεικτικού grader είναι `Protocol Violation: <MSG>`, όπου `<MSG>` είναι ένα από τα ακόλουθα μηνύματα σφάλματος:

* `invalid array`: σε κλήση της `are_connected`, τουλάχιστον ένας από τους πίνακες $A$ και $B$
    - είναι άδειος, ή
    - περιέχει ένα στοιχείο που δεν είναι ακέραιος αριθμός μεταξύ $0$ και $N-1$, συμπεριλαμβανομένων, ή
    - περιέχει το ίδιο στοιχείο τουλάχιστον δύο φορές.
* `non-disjoint arrays`: σε κλήση της `are_connected`, οι πίνακες $A$ και $B$ δεν είναι ασύνδετοι (not disjoint).
* `too many calls`: ο αριθμός των κλήσεων της `are_connected` υπερβαίνει τις $32\,640$ κατά την τρέχουσα κλήση της `longest trip`, ή υπερβαίνει συνολικά τις $150\,000$.
* `too many elements`: ο συνολικός αριθμός αξιοθέατων που στάληκαν στην `are_connected` σε όλες τις κλήσεις υπερβαίνει τις $1\,500\,000$.

Διαφορετικά, ας είναι τα στοιχεία του πίνακα που επιστρέφονται σε ένα σενάριο από την `longest_trip` τα $t[0], t[1], \ldots, t[l - 1]$ για κάποιο μη αρνητικό $l$.
Ο ενδεικτικός grader εκτυπώνει τρεις γραμμές για αυτό το σενάριο με την ακόλουθη μορφή:

* γραμμή $1$: $l$
* γραμμή $2$: $t[0] \; t[1] \; \ldots \; t[l-1]$
* γραμμή $3$: το πλήθος των κλήσεων στην `are_connected` για αυτό το σενάριο

Τέλος, ο ενδεικτικός grader τυπώνει:

* γραμμή $1 + 3 \cdot C$: το μέγιστο πλήθος κλήσεων της `are_connected` σε όλες τις κλήσεις της `longest_trip`