# Longest Trip

Skipuleggjendur IOI eru í miklum vanda! Þau gleymdu að plana ferðina til Ópusztaszer fyrir morgundaginn.
En kannski er það ekki alveg of seint...

Það eru $N$ kennileiti í Ópusztaszer sem eru númerið frá $0$ til $N-1$.
Sum pör þessarra kennileita eru tengd með *tvíáttuðum* **vegum**.
Sérhvert par kennileita er tengt með mesta lagi einum vegi.
Skipuleggjendurnir *vita ekki* hvaða kennileiti eru tengd með vegum.

Við segjum að **þéttleiki** vegakerfisins í Ópusztaszer er **í minnsta lagi** $\delta$ ef allar þrenndir af kennileitum hafa í minnsta lagi $\delta$ vegi á milli þeirra.
Í öðrum orðum, fyrir sérhverja þrennd af kennileitum $(u, v, w)$ þar sem $0 \le u \lt v \lt w \lt N$, af pörunum $(u,v), (v,w)$ og $(u,w)$ eru í minnsta lagi $\delta$ pör tengd með vegum.

Skipuleggjendurnir *vita* jákvæða heiltölu $D$ þar sem þéttleiki vegakerfisins er í minnsta lagi $D$.
Athugaðu að gildið á $D$ getur ekki verið stærra en $3$.

Skipuleggjendurnir geta framkvæmt **símtöl** til afgreiðslumanns í síma til að safna upplýsingum um vegatengingar milli ákveðinna kennileita.
Í sérhverju símtali verða tvö fylki sem eru ekki tóm, $[A[0], \ldots, A[P-1]]$ og $[B[0], \ldots, B[R-1]]$, tilgreind.
Kennileitin skulu vera sundurlæg tvö og tvö, eða í öðrum orðum
* $A[i] \neq A[j]$ fyrir sérhvert $i$ og $j$ þar sem $0 \le i \lt j \lt P$;
* $B[i] \neq B[j]$ fyrir sérhvert $i$ og $j$ þar sem $0 \le i \lt j \lt R$;
* $A[i] \neq B[j]$ fyrir sérhvert $i$ og $j$ þar sem $0 \le i \lt P$ og $0 \le j \lt R$.

Fyrir sérhvert símtal svarar afgreiðslumaður hvort það sé til vegur sem tengir kennileiti úr $A$ við kennileiti úr $B$.
Það er, afgreiðslumaðurinn skilar `true` ef það er til $i$ og $j$ þar sem $0 \le i \lt P$ og $0 \le j \lt R$, og $A[i]$ og $A[j]$ eru tengd með vegi.
Annars skilar afgreiðslumaðurinn `false`.

Ferðalag af lengd $l$ er runa af einstökum kennileitum $t[0], t[1], \ldots, t[l-1]$, þar sem fyrir sérhvert $i$ gildir að $0 \le i \le l-2$, og kennileiti $t[i]$ er tengt kennileiti $t[i+1]$ með vegi.
Ferðalag af lengd $l$ er flokkað sem **lengsta ferðalag** ef það er ekki til neitt ferðalag af lengd $l+1$.

Verkefni þitt er að hjálpa skipuleggjendunum að finna lengsta ferðalag í Ópusztaszer með því að hringja símtöl til afgreiðslumannsins.

## Útfærsluatriði

Þú skalt útfæra eftirfarandi fall:

```
int[] longest_trip(int N, int D)
```

* $N$: fjöldi kennileita í Ópusztaszer.
* $D$: tryggður minnsti þéttleiki vegakerfisins
* Þetta fall skal skila fylki $t = [t[0], t[1], \ldots, t[l-1]$, sem táknar eitthvað lengsta ferðalag.
* Sérhvert prufutilvik gæti kallað í þetta fall **mörgum sinnum**.

Fallið að ofan má kalla í eftirfarandi fall:

```
bool are_connected(int[] A, int[] B)
```

* $A$: fylki af einstökum kennileitum sem er ekki tómt.
* $B$: fylki af einstökum kennileitum sem er ekki tómt.
* $A$ og $B$ skulu vera sundurlæg.
* Þetta fall skilar `true` ef það er til kennileiti úr $A$ og kennileiti úr $B$ sem eru tengd með vegi. Annars skilar það `false`.
* Þetta fall má kalla í ekki oftar en $32\,640$ sinnum í sérhverri fallbeitingu af `longest_trip` og mesta lagi $150\,000$ sinnum samtals.
* Samtals lengd fylkja $A$ og $B$ sem eru send til fallsins yfir allar fallbeitingar þess má ekki vera hærri en $1\,500\,000$.

Yfirferðarforritið *aðlagar sig ekki*. Gildin $N$ og $D$, og einnig pör kennileita sem eru tengd með vegum, hafa verið ákvörðuð fyrirfram áður en fallinu `longest_trip` er beitt.

## Sýnidæmi

### Sýnidæmi 1

Hugsaðu um tilvik þar sem $N=5$, $D=1$ og vegirnir eru tengdir eins og sýnt er á eftirfarandi mynd:

![Example1](longesttrip-ex1.png "200")

Kallað er á fallið `longest_trip` á eftirfarandi hátt:
```
longest_trip(5, 1)
```

Fallið má kalla á `are_connected` á eftirfarandi hátt:

Kall                               | Pör tengd með vegi |  Skilagildi
:---------------------------------:|:-------------------------:|:--------------:
`are_connected([0], [1, 2, 4, 3])` | $(0,1)$ og $(0,2)$       | `true`
`are_connected([2], [0])`          | $(2,0)$                   | `true`
`are_connected([2], [3])`          | $(2,3)$                   | `true`
`are_connected([1, 0], [4, 3])`    | engin                      | `false`

Eftir fjórða kallið kemur í ljós að *ekkert* af pörunum $(1,4)$, $(0,4)$, $(1,3)$ og $(0,3)$ er tengd með vegi.
Þar sem þéttleiki kerfisins er í minnsta lagi $D = 1$, sjáum við að í þrenndini $(0, 3, 4)$ hlýtur parið $(3,4)$ að vera tengd með vegi.
Á svipaðan hátt má sjá að kennileiti $0$ og $1$ hljóta að vera tengd.

Á þessum tímapunkti má álykta að $t = [1, 0, 2, 3, 4$ sé ferðalag af lengd $5$ og að það sé ekki til ferðalag af lengd hærri en $5$.
Því má fallið `longest_trip` skila $[1, 0, 2, 3, 4]$.

Hugsaðu um annað tilvik þar sem $N = 4$, $D = 1$ og vegirnir eru tengdir eins og er sýnt á eftirfarandi mynd:

![Example2](longesttrip-ex2.png "200")

Kallað er í fallið `longest_trip` á eftirfarandi hátt:
```
longest_trip(4, 1)
```

Í þessu tilviki er lengdin á lengsta ferðalagi $2$. Eftir nokkur köll í `are_connected` má fallið `longest_trip` því skila út einu af $[0, 1]$, $[1, 0]$, $[2, 3]$ eða $[3, 2]$.

### Sýnidæmi 2

Hlutverkefni 0 inniheldur auka sýnidæmi með $N=256$ kennileitum.
Þetta sýnidæmi er innifalið í viðhengja pakkanum sem þú getur niðurhalað úr keppniskerfinu.

## Skorður

* $3 \le N \le 256$
* Summa allra gilda á $N$ yfir öll köll í `longest_trip` fer ekki yfir $1\,024$.
* $1 \le D \le 3$


## Hlutverkefni

1. (5 stig) $D = 3$
1. (10 stig) $D = 2$
1. (25 stig) $D = 1$. Látum $l^\star$ tákna lengdina á lengsta ferðalagi. Fallið `longest_trip` þarf ekki að skila ferðalagi af lengd $l^\star$, heldur skal það skila ferðalagi af lengd í minnsta lagi $\left\lceil \frac{l^\star}{2} \right\rceil$.
1. (60 stig) $D = 1$

Ef kall í `are_connected` skyldi í einhverju prufutilviki ekki fylgja skorðunum sem eru settar í Útfærsluatriði eða ef fylkið sem er skilað úr `longest_trip` er rangt mun lausnin þín fá 0 stig fyrir tilheyrandi hlutverkefnið.

Í hlutverkefni $4$ eru stigin þín ákvörður út frá fjölda kalla í fallið `are_connected` fyrir sérhverja fallbeitingu `longest_trip`.
Látum $q$ vera hámarksfjölda kalla yfir allar fallbeitingar `longest_trip` í öllum prufutilvikum þessa hlutverkefnis.
Stigin þín fyrir hlutverkefnið eru reiknuð með eftirfarandi töflu:

Skilyrði                  |  Stig
:-------------------------:|:----------------------:
$2\,750 \lt q \le 32\,640$ |  $20$
$550 \lt q \le 2\,750$     |  $30$
$400 \lt q \le 550$        |  $45$
$q \le 400$                |  $60$


## Sýnisyfirferðarforrit

Látum $C$ tákna fjölda tilvika, eða í öðrum orðum, fjöldi kalla í `longest_trip`.
Yfirferðarforritið sem þér er gefið til sýnis les inntakið á eftirfarandi sniði:

* line $1$: $C$

Lýsingar á $C$ tilvikum fylgja.

Yfirferðarforritið sem þér er gefið til sýnis les lýsinguna á hverju tilviki á eftirfarandi sniði:

* lína $1$: $N \; D$
* lína $1 + i$ ($1 \le i \lt N$): $U_i[0] \; U_i[1] \; \ldots \; U_i[i-1]$

Hér er sérhvert $U_i$, þar sem $1 \le i \lt N$, fylki af stærð $i$ sem lýsir hvaða pör kennileita eru tengd með vegi.
Fyrir sérhvert $i$ og $j$ þar sem $1 \le i \lt N$ og $0 \le j \lt i$:
* ef kennileiti $j$ og $i$ eru tengd með vegi skal gildið á $U_i[j]$ vera $1$;
* ef það er engin vegur sem tengir kennileiti $j$ og $i$ skal gildið á $U_i[j]$ vera $0$.

<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Í sérhverju tilviki mun sýnisyfirferðarforritið athuga hvort að þéttleiki vegakerfisins sé í minnsta lagi $D$, áður en kallað er í `longest_trip`.
Ef þetta skilyrði er ekki uppfylt mun það skrifa út skilaboðin `Insufficient Density` og hætta keyrslu.

Ef sýnisyfirferðarforritið tekur eftir brot á samskiptareglum mun úttakið vera `Protocol Violation: <MSG>`, þar sem `<MSG>` er eitt af eftirfarandi villuskilaboðum:

* `invalid array`: í kalli á `are_connected`, gildir að annaðhvort fylkið $A$ eða $B$
    - sé tómt, eða
    - inniheldur stak sem er ekki heiltala á bilinu $0$ upp í $N-1$, síðasta gildi þar með talið, eða
    - inniheldur sama stakið að minnsta kosti tvisvar.
* `non-disjoint arrays`: í kalli á `are_connected`, eru fylkin $A$ og $B$ ekki sundurlæg.
* `too many calls`: samtals fjöldi kalla í `are_connected` fer yfir $32\,640$ í núverandi fallbeitingu `longest trip`, eða fer yfir $150\,000$ samtals.
* `too many elements`: samtals fjöldi kennileita sem voru send inn í `are_connected` yfir öll köll fór yfir $1\,500\,000$.

Annars látum við stökin í fylkinu sem `longest_trip` skilaði í tilteknu tilviki vera $t[0], t[1], \ldots, t[l - 1]$ fyrir eitthvað gildi $l$ sem er ekki neikvætt.
Sýnisyfirferðarforritið skrifar út þrjár línur fyrir þetta tilvik á eftirfarandi sniði:

* lína $1$: $l$
* lína $2$: $t[0] \; t[1] \; \ldots \; t[l-1]$
* lína $3$: fjöldi kalla í `are_connected` í þessu tilviki

Að lokum skrifar sýnisyfirferðarforritið út:

* lína $1 + 3 \cdot C$: hámarksfjölda kalla í `are_connected` yfir öll köll í `longest_trip`.
