# Эң узак саякат

IOI 2023 уюштуруучулары чоң кыйынчылыкта! Алар келерки күнгө Ópusztaszer музейине сапарын пландаштырууну унутуп калышты.
Бирок балким али кеч эместир...

Ópusztaszerде $0$дөн $(N-1)$ге чейин индекстелген $N$ жербелги бар.
Бул жербелгилердин кээ бир жуптары *эки багыттуу* **жолдор** аркылуу туташтырылган.
Ар бир жуп жербелги эң көп дегенде бир жол менен байланышкан.
Уюштуруучулар кайсы жербелгилерди жолдор менен байланыштырганын *билбейт*.

Биз Ópusztaszerдеги жол тармагынын **жыштыгы** **жок дегенде** $\delta$ деп айтабыз, эгерде ар бир $3$ айырмаланган жербелгилердин арасында алардын арасында жок дегенде $\delta$ жолдор болсо.
Башкача айтканда, $0 \le u \lt v \lt w \lt N$, $(u,v), (v, w)$ жана $(u,w)$ жок дегенде $\delta$ жуптары жол аркылуу туташтырылган.

Уюштуруучулар жол тармагынын тыгыздыгы жок дегенде $D$ болушу үчүн $D$ оң бүтүн санын *билет*.
$D$ мааниси $3$төн жогору болбошуна көңүл буруңуз.

Уюштуруучулар Ópusztaszerдеги телефон диспетчерине **чалууларды** жасай алышат, кээ бир жербелгилердин ортосундагы жол байланыштары жөнүндө маалымат чогулта алышат.
Ар бир чалууда $[A[0], \ldots, A[P-1]]$ жана $[B[0], \ldots, B[R-1]]$ эки бош эмес массив көрсөтүлүшү керек.
Жербелгилердин жуптары айырмаланып турушу керек, б.а.
* $A[i] \neq A[j]$ ар бир $i$ жана $j$ үчүн $0 \le i \lt j \lt P$;
* $B[i] \neq B[j]$ ар бир $i$ жана $j$ үчүн $0 \le i \lt j \lt R$;
* $A[i] \neq B[j]$ ар бир $i$ жана $j$ үчүн $0 \le i \lt P$ жана $0\le j \lt R$.

Ар бир чалуу үчүн диспетчер $A$дан баштап жербелгини жана $B$дан баштап жербелгини бириктирген жол бар же жок экенин кабарлайт.
Тагыраак айтканда, диспетчер $0 \le i \lt P$ жана $0\le j \lt R$ болгон бардык $i$ жана $j$ түгөйлөрүн кайталайт.
Эгерде алардын кайсынысы үчүн $A[i]$ жана $B[j]$ жербелгилер жол менен туташтырылса, диспетчер "true" деп кайтарат.
Болбосо, диспетчер "false" деп кайтарып берет.

Узундугу $l$ болгон **саякат** - $t[0], t[1], \ldots, t[l-1]$, *өзгөчө* жербелгилердин ырааттуулугу,
мында $0$ жана $l-2$ ортосундагы ар бир $i$ үчүн, аны кошкондо, $t[i]$ жербелги жана $t[i+1]$ жербелги жол менен туташтырылган.
Узундугу $l$ болгон саякат **эң узак сапар** деп аталат, эгерде узундугу жок дегенде $l+1$ болгон саякат болбосо.

Сиздин милдет - уюштуруучуларга диспетчерге чалуу аркылуу Ópusztaszer боюнча эң узак сапарды табууга жардам берүү.

## Процедуранын чоо-жайы

Сиз төмөнкү процедураны ишке ашырууңуз керек:

```
int[] longest_trip(int N, int D)
```

* $N$: Ópusztaszerдеги жербелгилердин саны.
* $D$: жол тармагынын кепилденген минималдуу тыгыздыгы.
* Бул процедура эң узак сапарды билдирген $t = [t[0], t[1], \ldots, t[l-1]]$ массивдерин кайтарышы керек.
* Бул процедураны ар бир сыноодо **бир нече жолу** чакырышы мүмкүн.

Жогорудагы процедура төмөнкү процедурага чалууларды жасай алат:

```
bool are_connected(int[] A, int[] B)
```

* $A$: өзүнчө белгилердин бош эмес массиви.
* $B$: өзүнчө белгилердин бош эмес массиви.
* $A$ жана $B$ бири-биринен башка элементтер болушу керек.
* Эгер жол менен байланышкан $A$ жана $B$ белгиси бар болсо, бул процедура "true" деп кайтарат. Болбосо, ал "false" деп кайтарат.
* Бул процедураны эң көп дегенде $32\,640$ жолу `эң узун_саякат` чакырганда, ал эми жалпысынан эң көп дегенде $150\,000$ жолу чакырса болот.
* $A$ жана $B$ массивдеринин жалпы узундугу анын бардык чакырууларында бул процедурага өткөн $1\,500\,000$ ашпашы керек.

Грейдер **адаптивдүү эмес**. Ар бир тапшыруу бир эле тесттик иштердин топтому боюнча бааланат. Башкача айтканда, $N$ жана $D$ маанилери, ошондой эле жолдор менен байланышкан жербелгилердин жуптары ар бир сыноо учурунун ичинде ар бир "эң узун_саякат" чалуу үчүн белгиленет.

## Мисалдар

### 1-мисал

$N = 5$, $D = 1$ жана жол байланыштары төмөнкү сүрөттө көрсөтүлгөндөй болгон сценарийди карап көрөлү:

![Example1](longesttrip-ex1.png "200")

`longest_trip` процедурасы төмөнкүдөй деп аталат:
```
longest_trip(5, 1)
```

Процедура `are_connected` төмөнкүдөй чакырууларды аткара алат.

Чакыруу | Жол менен байланышкан жуптар | Кайтаруу мааниси
:---------------------------------:|:-------------------------:|:--------------:
`are_connected([0], [1, 2, 4, 3])` | $(0,1)$ and $(0,2)$       | `true`
`are_connected([2], [0])`          | $(2,0)$                   | `true`
`are_connected([2], [3])`          | $(2,3)$                   | `true`
`are_connected([1, 0], [4, 3])`    | none                      | `false`

Төртүнчү чалуудан кийин $(1,4)$, $(0,4)$, $(1,3)$ жана $(0,3)$ түгөйлөрүнүн *эч бири* бири-бири менен туташтырылбайт экен.
Тармактын тыгыздыгы жок дегенде $D = 1$ болгондуктан, $(0, 3, 4)$ үчтүктөн $(3,4)$ түгөйү жол аркылуу туташтырылышы керек экенин көрөбүз.
Ошол сыяктуу эле, $0$ жана $1$ жербелгилерди туташтыруу керек.

Бул жерден $t = [1, 0, 2, 3, 4]$ узундугу $5$ болгон саякат жана $5$тен ашкан саякат жок деген тыянак чыгарууга болот.
Демек, `longest_trip` процедурасы $[1, 0, 2, 3, 4]$ кайтарышы мүмкүн.

$N = 4$, $D = 1$ жана белгилердин ортосундагы жолдор төмөнкү сүрөттө көрсөтүлгөндөй болгон башка сценарийди карап көрөлү:

![Example2](longesttrip-ex2.png "200")

`longest_trip` процедурасы төмөнкүдөй жол менен чакырылат:

```
longest_trip(4, 1)
```

Бул сценарийде эң узак сапардын узактыгы $2$. Ошондуктан, `are_connected`, процедурасын бир нече чакыруудан кийин, `longest_trip` процедурасы $[0, 1]$, $[1, 0]$, $[2, 3]$ же $[3, 2]$'дын бирин кайтарышы мүмкүн.

### 2-мисал

0 - Кошумча тапшырма $N=256$ көрсөткүчү бар кошумча сыноо мисалын камтыйт.
Бул тест иши сиз сынак системасынан жүктөп ала турган тиркеме пакетине киргизилген.

## Чектөөлөр

* $3 \le N \le 256$
* `longest_trip` бардык чакыруулар үчүн $N$ суммасы ар бир тест  $1\,024$төн ашпайт.
* $1 \le D \le 3$

## Кошумча тапшырмалар

1. (5 упай) $D = 3$
1. (10 упай) $D = 2$
1. (25 упай) $D = 1$. $l^\star$ эң узак сапардын узактыгын белгилесин. `longest_trip`  жол-жобосу $l^\star$ узундугундагы сапарды кайтарууга милдеттүү эмес. Анын ордуна, ал кеминде $\left\lceil \frac{l^\star}{2} \right\rceil$ узундугун кайтарышы керек.
1. (60 упай) $D = 1$


4-кошумча тапшырмада сиздин упайыңыз `longest_trip` бир жолу чакырылышы боюнча `are_connected` процедурасына болгон чакыруулардын санына жараша аныкталат.
Кошумча тапшырманын ар бир сыноо учуру боюнча `longest_trip` чакырыктарынын ичиндеги чакыруулардын максималдуу саны $q$ болсун.
Бул кошумча тапшырма үчүн сиздин упайыңыз төмөнкү таблицага ылайык эсептелет:

Шарт                  |  Упайлар
:-------------------------:|:----------------------:
$2\,750 \lt q \le 32\,640$ |  $20$
$550 \lt q \le 2\,750$     |  $30$
$400 \lt q \le 550$        |  $45$
$q \le 400$                |  $60$

Эгерде сыноо учурларынын кайсы биринде, `are_connected` процедурасын чакыруулар процедуранын чоо-жайында сүрөттөлгөн чектөөлөргө туура келбесе, же `longest_trip` кайтарган массив туура эмес болсо, ал кошумча тапшырма үчүн чыгарылышыңыздын упайы $0$ болот.

## Үлгү Грейдер

$C$ сценарийлердин санын, башкача айтканда, `longest_trip` чалуулардын санын билдирсин.
Үлгү грейдер киргизүүнү төмөнкү форматта окуйт:

* $1$ - сап: $C$

$C$ сценарийинин сүрөттөмөлөрү төмөнкүдөй.

Үлгү грейдер ар бир сценарийдин сүрөттөмөсүн төмөнкү форматта окуйт:

* $1$ - сап: $N \; D$
* $(1 + i)$ - саптар ($1 \le i \lt N$): $U_i[0] \; U_i[1] \; \ldots \; U_i[i-1]$

Бул жерде ар бир $U_i$ ($1 \le i \lt N$) $i$ өлчөмүндөгү массив болуп, кайсы жуп жолбелгилердин жол менен туташтырылганын сүрөттөйт.
Ар бир $i$ жана $j$ үчүн $1 \le i \lt N$ жана $0 \le j \lt i$:
* эгерде $j$ жана $i$ жолбелгилер жол аркылуу байлаган болсо, анда $U_i[j]$ мааниси $1$ болушу керек;
* эгерде $j$ жана $i$ жолбелгилерди байлаган жол жок болсо, анда $U_i[j]$ мааниси $0$ болушу керек.

<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Ар бир сценарийде,  `longest_trip` чакыруудан мурун үлгү грейдер жол тармагынын тыгыздыгы жок дегенде $D$ экендигин текшерет.
Эгерде бул шарт аткарылбаса, ал `Insufficient Density`  билдирүүсүн басып чыгарат жана токтойт.

Эгерде үлгүдөгү грейдер протоколдун бузулушун аныктаса, үлгү грейдердин чыгарылышы `Protocol Violation: <MSG>` болот, мында `<MSG>` төмөнкү ката билдирүүлөрүнүн бири:

*  `invalid array`: `are_connected` чакырыгында $A$ жана $B$ массивдердин жок дегенде бири
     - бош, же
     - $0$ жана $N-1$ ортосундагы бүтүн сан болбогон элементти камтыйт, же камтыган
     - бир эле элементти кеминде эки жолу камтыса.
* `non-disjoint arrays`: `are_connected` чакырыгында $A$ жана $B$ массивдери ажырашпайт.
* `too many calls`: `are_connected` үчүн жасалган чалуулардын саны учурдагы `longest trip` чакыруусунан $32\,640$ ашат же жалпысынан $150\,000$ ашат.
* `too many elements`: бардык чакыруулар боюнча `are_connected` дегенге өткөн белгилердин жалпы саны $1\,500\,000$ ашат.


Болбосо, сценарийде `longest_trip` тарабынан кайтарылган массивдин элементтери кээ бир терс эмес $l$ үчүн $t[0], t[1], \ldots, t[l - 1]$ болсун.
Үлгү грейдер бул сценарий үчүн үч сапты төмөнкү форматта басып чыгарат:

* $1$ - сап : $l$
* $2$ - сап: $t[0] \; t[1] \; \ldots \; t[l-1]$
* $3$ -  сап: бул сценарий боюнча `are_connected` чакыруулардын саны

Акырында, үлгү грейдер басып чыгарат:

* сап $1 + 3 \cdot C$: `longest_trip` бардык чакыруулар боюнча `are_connected` чакыруулардын максималдуу саны

