# Хамгийн урт аялал

IOI 2023-ын зохион байгуулагч нарт том асуудал тулгарчээ! Тэд удахгүй болох Опустазер руу хийх аялалаа төлөвлөхөө мартжээ. 
Гэхдээ одоохондоо оройтоогүй байж магадгүй ...

Опустазерт $0$-ээс $N-1$ хүртлэх тоонуудаар дугаарлагдсан $N$ тооны дурсгалт газар байдаг. 
Эдгээр дурсгалт газруудын зарим хос нь хоорондоо *хоёр чиглэлтэй* **замуудаар** холбогдсон байдаг.
Дурсгалт газар бүр дээд тал нь нэг замаар холбогдсон байна.
Зохион байгуулагч нар аль дурсгалт газрууд замаар холбогдсоныг *мэдэхгүй*.

Хэрэв Опустазерын $3$ ялгаатай дурсгалт газар бүр хоорондоо дор хаяж $\delta$ тооны замтай бол замын сүлжээ нь **дор хаяж** $\delta$ **нягттай** байна гэж хэлнэ. 
Өөрөөр хэлбэл $0 \le u \lt v \lt w \lt N$ байх $(u, v, w)$ дурсгалт газрын гурвал бүрийн хувьд $(u,v), (v,w)$ ба $(u,w)$ гэсэн дурсгалт газрын хосуудаас дор хаяж $\delta$ нь замаар холбогдсон байх юм. 

Зохион байгуулагч нар замын сүлжээний нягт нь дор хаяж $D$ байх тийм $D$ эерэг бүхэл тоог *мэддэг*. 
$D$ нь $3$-аас их байж болохгүйг анхаараарай.

Зохион байгуулагч нар Опустазер дахь утасны оператор руу **дуудлага** хийж тодорхой дурсгалт газруудыг хоорондоо замаар холбогдсон эсэх талаар мэдээллийг цуглуулж чадна. 
Дуудлага бүрт $[A[0], \ldots, A[P-1]]$ ба $[B[0], \ldots, B[R-1]]$ гэсэн дурсгалт газруудын хоёр хоосон биш массивыг зааж өгөх ёстой.
Дурсгалт газрууд хос хосоороо ялгаатай байх ёстой буюу дараах нөхцөлийг хангаж байна,
* $0 \le i \lt j \lt P$ байх $i$ ба $j$ бүрийн хувьд $A[i] \neq A[j]$;
* $0 \le i \lt j \lt R$ байх $i$ ба $j$ бүрийн хувьд $B[i] \neq B[j]$;
* $0 \le i \lt P$ ба $0\le j \lt R$ байх $i$ ба $j$ бүрийн хувьд $A[i] \neq B[j]$.

Дуудлага бүрийн хувьд оператор $A$ дурсгалт газраас $B$-г холбосон зам байгаа эсэх талаар хариулна.
Тодруулбал, оператор $0 \le i \lt P$ ба $0 \le j \lt R$ байх бүх $i$ ба $j$ хосууд дээр  давтана. Хэрэв тэдгээрийн аль нэгнийх нь хувьд $A[i]$ ба $B[j]$ газрууд замаар холбосон бол оператор `true` утга буцаана. Бусад тохиолдолд оператор `false` утга буцаана.

$l$ урттай **аялал** гэж $i$-гийн $0$-ээс $l-2$ хүртлэх утга бүрийн хувьд $t[i]$ ба $t[i+1]$ дурсгалт газрууд замаар холбогдсон байх $t[0], t[1], \ldots, t[l-1]$ гэсэн *ялгаатай* дурсгалт газруудын дарааллыг хэлнэ.
Хэрэв дор хаяж $l+1$ урттай аялал оршин байдаггүй бол $l$ урттай аяллыг **хамгийн урт аялал** гэж нэрлэнэ.

Таны даалгавар бол оператор руу дуудлагууд хийх замаар зохион байгуулагч нарт хамгийн урт аяллыг олоход нь туслах явдал юм.

## Хэрэгжүүлэлтийн мэдээлэл

Та доорх процедурыг хэрэгжүүлнэ:

```
int[] longest_trip(int N, int D)
```

* $N$: Опустазер дахь дурсгалт газрын тоо.
* $D$: замын сүлжээний баталгаат минимум нягт.
* Энэ процедур нь хамгийн урт аяллыг илэрхийлэх $t = [t[0], t[1], \ldots, t[l-1]]$ массивыг буцаана.
* Энэ процедурыг тест бүр дээр **олон удаа** дуудаж болно.

Дээрх процедур нь доорх процедурыг дуудаж болно:

```
bool are_connected(int[] A, int[] B)
```

* $A$: ялгаатай дурсгалт газруудын хоосон биш массив.
* $B$: ялгаатай дурсгалт газруудын хоосон биш массив.
* $A$ ба $B$ нь огтлолцолгүй байна.
* Энэ процедур нь $A$-гийн аль нэг дурсгалт газар $B$-гийн аль нэг дурсгалт газартай замаар холбогдсон бол `true` утгыг буцаана. Эсрэг тохиолдолд `false` утгыг буцаана.
* Уг процедурыг `longest_trip`-ын дуудалт бүрийн хувьд дээд тал нь $32\,640$ удаа, нийтдээ дээд тал нь $150\,000$ удаа дуудаж болно.
* Уг процедурын бүх дуудалтуудын хувьд энэ процедурт дамжуулсан $A$ ба $B$ массивуудын нийт урт нь $1\,500\,000$ утгаас хэтэрч болохгүй.

Шалгагч нь **дасан зохицдоггүй** байна. $N$ ба $D$ утгууд болон замаар холбогдсон дурсгалт газрын хосуудын тоо нь `longest_trip`-ийн дуудалт хийгдэхээс өмнө бэхлэгдсэн байна.

## Жишээ

### Жишээ 1

$N = 5$, $D = 1$ байх бөгөөд замуудын холболт нь доорх зурагт үзүүлснээр байх тохиолдлыг авч үзье:

![Example1](longesttrip-ex1.png "200")

`longest_trip` процедурыг доорх байдлаар дуудна:
```
longest_trip(5, 1)
```

Уг процедур нь `are_connected`-ыг доорх байдлаар дуудаж болно.

Дуудалт                               | Замаар холбогдсон хосууд |  Буцаах утга
:---------------------------------:|:-------------------------:|:--------------:
`are_connected([0], [1, 2, 4, 3])` | $(0,1)$ ба $(0,2)$       | `true`
`are_connected([2], [0])`          | $(2,0)$                   | `true`
`are_connected([2], [3])`          | $(2,3)$                   | `true`
`are_connected([1, 0], [4, 3])`    | байхгүй                      | `false`

Дөрөв дэх дуудалтын дараа $(1,4)$, $(0,4)$, $(1,3)$ ба $(0,3)$ хосуудын *аль нь ч* замаар холбогдоогүй гэдэг нь тодорхой болно.
Сүлжээний нягт нь дор хаяж $D = 1$ байна гэдгээс $(0, 3, 4)$ гурвалаас $(3,4)$ хос нь замаар холбогдох ёстой гэж гарна.
Үүнтэй адилаар $0$ ба $1$ дурсгалт газрууд холбоотой байх ёстой байна.

Энэ үед $t = [1, 0, 2, 3, 4]$ нь $5$ урттай аялал бөгөөд $5$-аас илүү урттай аялал байхгүй гэж дүгнэж болно.
Иймд `longest_trip` нь $[1, 0, 2, 3, 4]$ утгыг буцааж болно.

$N = 4$, $D = 1$ байх бөгөөд замуудын холболт нь доорх зурагт үзүүлснээр байх өөр нэг тохиолдлыг авч үзье:

![Example2](longesttrip-ex2.png "200")

`longest_trip` процедурыг доорх байдлаар дуудна:
```
longest_trip(4, 1)
```

Энэ тохиолдолд хамгийн урт аяллын урт нь $2$ байна. Иймд `are_connected`-ыг хэдэн удаа дуудсаны дараа `longest_trip` процедур нь $[0, 1]$, $[1, 0]$, $[2, 3]$ эсвэл $[3, 2]$ утгуудын аль нэгийг буцааж болно.

### Жишээ 2

Дэд бодлого 0 нь $N=256$ дурсгалт газар бүхий нэмэлт жишээ тестийг агуулна.
Энэ тест нь тэмцээний систем доторх таны татаж авч болох хавсралтын багцад агуулагдаж байгаа.

## Хязгаарлалт

* $3 \le N \le 256$
* `longest_trip`-ийн бүх дуудалтуудын $N$-үүдийн нийлбэр нь $1\,024$ гэсэн утгаас хэтрэхгүй.
* $1 \le D \le 3$


## Дэд бодлого

1. (5 оноо) $D = 3$
1. (10 оноо) $D = 2$
1. (25 оноо) $D = 1$. $l^\star$ нь хамгийн урт аяллын урт байг. `longest_trip` процедур нь $l^\star$ урттай аяллыг буцаах албагүй. Харин уг процедур дор хаяж $\left\lceil \frac{l^\star}{2} \right\rceil$ урттай аяллыг буцаана.
1. (60 оноо) $D = 1$

Дэд бодлого 4 дээр таны оноог `longest_trip`-ын нэг дуудалт дээр `are_connected` процедурыг хэдэн удаа дуудсан дээр үндэслэн тодорхойлно.
$q$ нь уг дэд бодлогын тест бүр дээрх `longest_trip`-ийн бүх дуудалтуудын хувьд хамгийн олон удаа дуудсан тоо байг.
Уг дэд бодлого дээрх таны оноог доорх хүснэгтийн дагуу тооцоолно:

Нөхцөл                  |  Оноо
:-------------------------:|:----------------------:
$2\,750 \lt q \le 32\,640$ |  $20$
$550 \lt q \le 2\,750$     |  $30$
$400 \lt q \le 550$        |  $45$
$q \le 400$                |  $60$

Хэрэв аль нэг тест дээр `are_connected`-ын дуудалтууд нь Хэрэгжүүлэлтийн мэдээлэл дээр бичсэн хязгаарлалтуудыг хангахгүй бол эсвэл `longest_trip`-ийн буцаасан массив нь буруу бол таны бодолтын тухайн дэд бодлого дээрх оноо нь  $0$ болно.

## Жишээ шалгагч

$C$-гээр тохиолдлын тоо буюу `longest_trip`-ийн дуудалтын тоог тэмдэглэе.
Жишээ шалгагч нь оролтыг доорх хэлбэрээр уншина:

* мөр $1$: $C$

$C$ тооны тохиолдлын тайлбар нь доорх байдалтай байна.

Жишээ шалгагч нь тохиолдол бүрийн тодорхойлолтыг доорх хэлбэрээр уншина:

* мөр $1$: $N \; D$
* мөр $1 + i$ ($1 \le i \lt N$): $U_i[0] \; U_i[1] \; \ldots \; U_i[i-1]$

Энд $U_i$ ($1 \le i \lt N$) бүр нь $i$ хэмжээтэй массив ба аль дурсгалт газрууд замаар холбогдсоныг илэрхийлнэ.
$1 \le i \lt N$ ба $0 \le j \lt i$ байх $i$ болон $j$ бүрийн хувьд:
* хэрэв $j$ ба $i$ дурсгалт газрууд замаар холбогдсон бол $U_i[j]$-гийн утга нь $1$ байна;
* хэрэв $j$ ба $i$ дурсгалт газруудыг холбосон зам байхгүй бол $U_i[j]$-гийн утга нь $0$ байна.

<!-- IMPORTANT NOTE TO TRANSLATORS: THE FOLLOWING MESSAGES (IN BACKTICKS) SHOULD NOT BE TRANSLATED -->

Тохиолдол бүрийн хувьд `longest_trip`-ыг дуудахын өмнө жишээ шалгагч нь замын сүлжээний нягт нь дор хаяж $D$ байгаа эсэхийг шалгана.
Хэрэв энэ нөхцөл хангагдаагүй байвал `Insufficient Density` мэдэгдлийг хэвлээд гарна.

Хэрэв жишээ шалгагч нь протоколын зөрчил илрүүлбэл жишээ шалгагчийн гаралт нь `Protocol Violation: <MSG>` хэлбэртэй байх ба энд `<MSG>` нь доорх алдааны мэдэгдлүүдийн нэг байна:

* `invalid array`: `are_connected`-ын дуудалтын үед $A$ ба $B$ массивуудын дор хаяж нэг нь 
    - хоосон, эсвэл
    - $0$-ээс $N-1$ хүртлэх бүхэл тоо биш байх элемент агуулсан, эсвэл 
    - нэг элементийг дор хаяж хоёр удаа агуулсан.
* `non-disjoint arrays`: `are_connected`-ын дуудалтын үед $A$ ба $B$ массивууд нь огтлолцоогүй биш байх.
* `too many calls`: `are_connected`-ын дуудалтын тоо нь `longest trip`-ын нэг дуудалтын хувьд $32\,640$ утгаас хэтэрсэн эсвэл нийтдээ $150\,000$ утгаас хэтэрсэн.
* `too many elements`: `are_connected`-ын бүх дуудалтын хувьд түүн рүү дамжуулсан дурсгалт газруудын нийт тоо нь $1\,500\,000$ утгаас хэтэрсэн.


Эсрэг тохиолдолд `longest_trip`-ын ямар нэг тохиолдлын хувьд буцаасан массивыг $t[0], t[1], \ldots, t[l - 1]$ гэж тэмдэглэе ( $l$ нь сөрөг бус бүхэл тоо).
Жишээ шалгагч нь энэ тохиолдлын хувьд доорх хэлбэрээр гурван мөрийг хэвлэнэ:

* мөр $1$: $l$
* мөр $2$: $t[0] \; t[1] \; \ldots \; t[l-1]$
* мөр $3$: энэ тохиолдол дахь `are_connected`-ын дуудалтын тоо 

Эцэст нь жишээ шалгагч доорхийг хэвлэнэ:

* мөр $1 + 3 \cdot C$: `longest_trip`-ийн дуудалтууд дотроос `are_connected`-ыг дуудсан хамгийн их тоо 
